local e=require"nixio.fs"
local o=require"luci.sys"
local a=Map("supervisord",translate("Supervisord"),translate("A golang development process management")..[[<br /><br /><a href="https://github.com/sundaqiang/openwrt-packages" target="_blank">Powered by sundaqiang</a>]])
a:section(SimpleSection).template="supervisord/index"
s=a:section(TypedSection,"supervisord")
s.addremove=false
s.anonymous=true
s:tab("general",translate("General Settings"))
s:tab("advanced",translate("Configuration File"))
s:tab("list",translate("Task List"))
s:tab("log",translate("Log List"))
f=s:taboption("general",Flag,"enabled",translate("Enabled"))
f.rmempty=false
v=s:taboption("general",Value,"filepath",translate("File Path"))
v.rmempty=false
v=s:taboption("general",Flag,"usechinamirror",translate("Use China Mirror"))
v.rmempty=false
b=s:taboption("general",Button,"")
b.template="supervisord/version"
file=s:taboption("advanced",TextValue,"")
file.template="cbi/tvalue"
file.rows=15
file.wrap="off"
file.rmempty=false
l=s:taboption("list",DummyValue,"")
l.template="supervisord/list"
l.list={}
index=1
for t in e.dir("/etc/supervisord/program")do
if t:find(".ini$")~=nil then
name=e.readfile("/etc/supervisord/program/"..t)
l.list[index]={}
l.list[index][1]=name:match("program:(%a+)")
l.list[index][2]="/etc/supervisord/program/"..t
local e=name:match("directory=([%a%d%p ]+)").."/"..name:match("getversions=([%a%d%p ]+)")
l.list[index][3]=o.exec(e)
index=index+1
end
end
g=s:taboption("log",DummyValue,"")
g.template="supervisord/log"
g.list=l.list
function s.create(t,e)
return TypedSection.create(t,e)
end
function s.remove(e,t)
return TypedSection.remove(e,t)
end
function sync_value_to_file(n,i,t,a)
t=t:gsub("\r\n?","\n")
local o=e.readfile(a)
if t~=o then
e.writefile(a,t)
n.map:set(i,"amend","1")
end
end
function file.cfgvalue(t,t)
return e.readfile("/etc/supervisord/supervisord.conf")or""
end
function file.write(e,t,a)
sync_value_to_file(e,t,a,"/etc/supervisord/supervisord.conf")
end
return a