module("luci.controller.supervisord",package.seeall)
function index()
if not nixio.fs.access("/etc/config/supervisord")then return end
entry({"admin","services","supervisord"},cbi("supervisord"),_("Supervisord"),95).dependent=true
entry({"admin","services","supervisord","status"},call("status")).leaf=true
entry({"admin","services","supervisord","getver"},call("getver")).leaf=true
entry({"admin","services","supervisord","update"},call("update")).leaf=true
entry({"admin","services","supervisord","gettask"},call("gettask")).leaf=true
entry({"admin","services","supervisord","starttask"},call("starttask")).leaf=true
entry({"admin","services","supervisord","restarttask"},call("restarttask")).leaf=true
entry({"admin","services","supervisord","stoptask"},call("stoptask")).leaf=true
entry({"admin","services","supervisord","removetask"},call("removetask")).leaf=true
entry({"admin","services","supervisord","addtask"},call("addtask")).leaf=true
entry({"admin","services","supervisord","savetask"},call("savetask")).leaf=true
entry({"admin","services","supervisord","getlog"},call("getlog")).leaf=true
end
function Split(a,e,t)
if string.find(a,e)==nil then
return{a}
end
if t==nil or t<1 then
t=0
end
local o={}
local n="(.-)"..e.."()"
local e=0
local i
for a,n in string.gfind(a,n)do
e=e+1
o[e]=a
i=n
if e==t then break end
end
if e~=t then
o[e+1]=string.sub(a,i)
end
return o
end
function status()
local e={}
e.running=luci.sys.call("ps | grep supervisord | grep -v grep >/dev/null")==0
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function getver()
local e={}
local t=luci.model.uci.cursor()
local t=t:get("supervisord","main","filepath")
e.nowver=luci.sys.exec(t.." version")
e.newver=luci.sys.exec("uclient-fetch -qO- 'https://api.github.com/repos/ochinchina/supervisord/releases/latest' | jsonfilter -e '@.tag_name'")
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function update()
local e={}
local i=luci.model.uci.cursor()
local o=i:get("supervisord","main","filepath")
local a=luci.http.formvalue('version')
local t=nixio.uname().machine or""
a=a:gsub("\n","")
if nixio.fs.access("/usr/lib/os-release")then
LEDE_BOARD=luci.sys.exec("echo -n $(grep 'LEDE_BOARD' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}')")
end
if nixio.fs.access("/etc/openwrt_release")then
DISTRIB_TARGET=luci.sys.exec("echo -n $(grep 'DISTRIB_TARGET' /etc/openwrt_release | awk -F '[\\042\\047]' '{print $2}')")
end
t=luci.util.trim(t)
if t=="x86_64"then
t="64-bit"
end
filename="supervisord_"..a:gsub("v","").."_Linux_"..t..".tar.gz"
nixio.fs.remove("/tmp/"..filename)
u=i:get("supervisord","main","usechinamirror")
e.error=luci.sys.call("uclient-fetch -qO- -O '/tmp/"..filename.."' '"..u.."https://github.com/ochinchina/supervisord/releases/download/"..a.."/"..filename.."'")
if e.error==0 then
e.error=luci.sys.exec("tar -xzvf '/tmp/"..filename.."' -C /tmp")
if e.error then
e.error=nixio.fs.mover("/tmp/"..filename:gsub(".tar.gz","").."/supervisord",o)
if e.error then
e.error=0
sysupgrade=nixio.fs.readfile("/etc/sysupgrade.conf")
if not sysupgrade:find(o)then
sysupgrade=sysupgrade..'\n'..o
nixio.fs.writefile("/etc/sysupgrade.conf",sysupgrade)
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
else
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
else
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
end
function gettask()
local e={}
local t=luci.http.formvalue('name')
local t=luci.sys.exec("supervisord ctl status "..t)
e.status=string.gsub(string.sub(t,34,50)," ","")
e.description=string.sub(t,51)
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function starttask()
local e={}
local t=luci.http.formvalue('name')
local t=luci.sys.exec("supervisord ctl start "..t)
if string.find(t,"started")~=nil then
e.code=1
else
e.code=0
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function restarttask()
local e={}
local t=luci.http.formvalue('name')
local t=luci.sys.exec("supervisord ctl stop "..t.." && supervisord ctl start "..t)
if string.find(t,"started")~=nil then
e.code=1
else
e.code=0
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function stoptask()
local e={}
local t=luci.http.formvalue('name')
local t=luci.sys.exec("supervisord ctl stop "..t)
if string.find(t,"stopped")~=nil then
e.code=1
else
e.code=0
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function removetask()
local e={}
local t=luci.http.formvalue('name')
e.code=nixio.fs.remove('/etc/supervisord/program/'..t..'.ini')
if e.code then
luci.sys.call("supervisord ctl reload")
e.code=1
else
e.code=0
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function addtask()
local e={}
local t=luci.http.formvalue('name')
if nixio.fs.access('/etc/supervisord/program/'..t..'.ini')then
e.code=2
luci.http.prepare_content("application/json")
luci.http.write_json(e)
return
end
file=nixio.fs.readfile("/etc/supervisord/program/templates")
file=file:gsub("demo",t)
e.code=nixio.fs.writefile('/etc/supervisord/program/'..t..'.ini',file)
if e.code then
luci.sys.call("supervisord ctl reload")
e.code=1
e.data=file
else
e.code=0
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function savetask()
local e={}
local a=luci.http.formvalue('name')
local t=luci.http.formvalue('data')
t=t:gsub("\r\n?","\n")
file='/etc/supervisord/program/'..a..'.ini'
e.code=nixio.fs.writefile(file,t)
if e.code then
sysupgrade=nixio.fs.readfile("/etc/sysupgrade.conf")
if not sysupgrade:find(file)then
sysupgrade=sysupgrade..'\n'..file
end
backupfile=t:match("backupfile=([%a%d%p]+)")
backupfile=Split(backupfile,"||")
for t,e in ipairs(backupfile)do
if not sysupgrade:find(e:gsub("%p","%%%1"))then
sysupgrade=sysupgrade..'\n'..e
end
end
nixio.fs.writefile("/etc/sysupgrade.conf",sysupgrade)
luci.sys.call("supervisord ctl reload")
e.code=1
else
e.code=0
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function getlog()
local e={}
local a=luci.http.formvalue('name')
if a=="main"then
local t=nixio.fs.readfile('/etc/supervisord/supervisord.conf')
t=string.match(t,"logfile=([%a%d%p]+)")
e.data=nixio.fs.readfile(t)
else
local t=nixio.fs.readfile('/etc/supervisord/program/'..a..'.ini')
t=string.match(t,"stdout_logfile=([%a%d%p]+)")
e.data=nixio.fs.readfile(t)
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end